import { InjectionToken } from '@angular/core';
import { BindingApi, BindingParams } from '@tweakpane/core';
import * as i0 from "@angular/core";
import * as i1 from "./blade";
import * as i2 from "./debounce";
import * as i3 from "./label";
export type NgtTweakBindingParams<TParams extends BindingParams> = Omit<TParams, 'tag' | 'label' | 'disabled' | 'hidden'>;
export declare const NGT_TWEAK_BINDING_AS_HOST: InjectionToken<true | {
    in: (value: unknown) => unknown;
    out: (value: unknown) => unknown;
} | null>;
export declare function provideTweakBindingAsHost<TIn, TOut>(inOut?: {
    in: (value: TIn) => TOut;
    out: (value: TOut) => TIn;
}): {
    provide: InjectionToken<true | {
        in: (value: unknown) => unknown;
        out: (value: unknown) => unknown;
    } | null>;
    useValue: boolean | {
        in: (value: TIn) => TOut;
        out: (value: TOut) => TIn;
    };
};
export declare class NgtTweakBinding<TValue> {
    value: import("@angular/core").ModelSignal<TValue>;
    private debounce;
    private label;
    private blade;
    private parent;
    private injector;
    private asHostDirective;
    binding: import("@angular/core").WritableSignal<BindingApi<unknown, TValue, import("@tweakpane/core/dist/blade/binding/controller/binding").BindingController<unknown, import("@tweakpane/core").ValueController<unknown, import("@tweakpane/core").View, import("@tweakpane/core").Value<unknown>>, import("@tweakpane/core").BindingValue<unknown>>> | null>;
    private bindingBaseParams;
    private get bindableObject();
    constructor();
    createBindingEffect(params: () => BindingParams): import("@angular/core").EffectRef;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtTweakBinding<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtTweakBinding<any>, "ngt-tweak-binding", never, { "value": { "alias": "value"; "required": true; "isSignal": true; }; }, { "value": "valueChange"; }, never, never, true, [{ directive: typeof i1.NgtTweakBlade; inputs: { "disabled": "disabled"; "hidden": "hidden"; }; outputs: {}; }, { directive: typeof i2.NgtTweakDebounce; inputs: { "debounce": "debounce"; }; outputs: {}; }, { directive: typeof i3.NgtTweakLabel; inputs: { "label": "label"; "tag": "tag"; }; outputs: {}; }]>;
}
